<?php

namespace Treewec;

/**
 * Test class for PublicURLInspector.
 * Generated by PHPUnit on 2012-07-03 at 14:43:39.
 * @group url
 */
class PublicURLInspectorTest extends \PHPUnit_Framework_TestCase {

    /** @var ExceptionHelper */
    private $exceptionHelper;
    /** @var PublicURLInspector */
    private $inspector;

    protected function setUp() {
        $this->exceptionHelper = new ExceptionHelper();
    }

    public function testCheck() {
        // only hidden files cannot be displayed in public + invalid path (tested in URLArgsInspectorTest)
        $invalid = array(TREEWEC_PREFIX_OF_HIDDEN_FILES . 'name', 'folder/' . TREEWEC_PREFIX_OF_HIDDEN_FILES . 'name');
        foreach ($invalid as $invalidValue) {
            $this->setInspectorAndAssertException(array('path' => $invalidValue));
        }
    }

    private function setInspectorAndAssertException($array) {
        $this->setInspector($array);
        $this->assertException();
    }
    
    private function setInspector($array) {
        if (!array_key_exists('path', $array)) {
            $array = array_merge($array, array('path' => ''));// add valid path
        }
        $this->inspector = new PublicURLInspector();
        $arrayHolder = new Holders\ArrayHolder($array);
        $this->inspector->addInspectedObject(URLArgs::createFromArrayHolder($arrayHolder));
    }
    
    private function assertException() {
        $this->exceptionHelper->catchExceptionInCallback(
                '\Treewec\Exceptions\ClientRequestException', 
                array($this->inspector, 'check'), 
                false
        );
    }
    
}

?>
